const channel = 'akaruu'

let init = 1
let stockItem
let initItem = 1
let openNotifYoutube = 0
let nowDate = new Date()

let hour = nowDate.getHours()
let min = nowDate.getMinutes()

let options = {
  part: 'snippet',
  key: 'AIzaSyC-flM-Q9ZMr8ZYqQohjqXVLKCBDjyifqg',
  maxResults: 4,
  playlistId: 'PLsG8pVQsbEDbOiLts2HFnO2A4bh-pCw78'
}
const urlPlaylist = 'https://www.googleapis.com/youtube/v3/playlistItems' + '?part=' + options.part + "&playlistId=" + options.playlistId + "&maxResults=" + options.maxResults + "&key=" + options.key

let recentIdVideo
let recentVideos = new Array()
let recentVideo = function (title, thumbnail, time) {
  this.title = title
  this.thumbnail = thumbnail
  this.time = time
}

let lastVideos = new Array()
let lastVideo = function (thumbnail, id) {
  this.thumbnail = thumbnail
  this.id = id
}

let ajaxTwitch = async function () {

  try {

    let response = await fetch("https://bridge.buddyweb.fr/api/akaruuextension/streams")

    if (response.ok) {
      let value = await response.json()

      if (value[0].live === 'true') {

        toogleStream(true)
        localStorage.setItem('status', true)
        localStorage.setItem('title', value[0].title)

        if (init === 1) {
          notifyTwitch(value[0].title)
          init = 2
        }

      } else {
        toogleStream(false)
        init = 1
        localStorage.setItem('status', false)
      }
    } else {
      console.error("Retour du serveur : " + response.status)
    }

  } catch (e) {
    console.error(e)
  }

}

let ajaxYoutube = async function () {
  try {
    let response = await fetch(urlPlaylist)

    if (response.ok) {
      let dataPlaylist = await response.json()

      if (dataPlaylist.items.length !== 0) {

        recentIdVideo = dataPlaylist.items[0].snippet.resourceId.videoId

        stockItem = localStorage.getItem('id')

        if (stockItem !== recentIdVideo || initItem === 1) {
          initItem = 2

          recentVideos = []
          lastVideos = []

          try {
            let urlVideo = 'https://www.googleapis.com/youtube/v3/videos?part=contentDetails%2C%20snippet&id=' + recentIdVideo + '&key=' + options.key
            let response = await fetch(urlVideo)

            if (response.ok) {
              let dataVideo = await response.json()

              recentVideos.push(new recentVideo(dataVideo.items[0].snippet.title, dataVideo.items[0].snippet.thumbnails.medium.url, convertISO8601Duration(dataVideo.items[0].contentDetails.duration)))
              localStorage.setItem('dataRecentVideo', JSON.stringify(recentVideos))
            }
          } catch (e) {
            console.error(e)
          }

          if (dataPlaylist.items.length > 1) {

            for (let i = 1; i < dataPlaylist.items.length; i++) {

              if (i < 3) {
                lastVideos.push(new lastVideo(dataPlaylist.items[i].snippet.thumbnails.medium.url, dataPlaylist.items[i].snippet.resourceId.videoId))
              }

            }
            localStorage.setItem('dataLastVideos', JSON.stringify(lastVideos))

          }

          localStorage.setItem('id', recentIdVideo)

          if (openNotifYoutube === 1) {
            notifyYoutube()
          } else {
            openNotifYoutube = 1
          }

        }

      }

    }

  } catch (e) {
    console.error(e)
  }
}

function notifyTwitch(streamTitle) {

  chrome.notifications.create(channel, {
    type: "basic",
    iconUrl: "src/img/twitch-1.png",
    title: "Akaruu est en stream !",
    message: streamTitle,
    silent: true,
    priority: 2
  });

}

function notifyYoutube() {

  chrome.notifications.create(options.playlistId, {
    type: "basic",
    iconUrl: "src/img/youtube-1.png",
    title: "Akaruu - Nouvelle vidéo !",
    message: recentVideos[0].title,
    silent: true,
    priority: 2
  });

}

chrome.notifications.onClicked.addListener(function (e) {
  if (e === channel) {
    window.open("https://www.twitch.tv/" + channel)
    chrome.notifications.clear(channel)
  } else if (e === options.playlistId) {
    window.open('https://www.youtube.com/watch?v=' + localStorage.getItem('id'))
    chrome.notifications.clear(options.playlistId)
  }
})

function toogleStream(value) {
  if (value == true) {
    chrome.browserAction.setTitle({
      title: "Akaruu - live"
    })

    chrome.browserAction.setIcon({
      path: {
        "128": "src/img/icon_on.png"
      }
    })
  } else {
    chrome.browserAction.setTitle({
      title: "Akaruu - hors ligne"
    })

    chrome.browserAction.setIcon({
      path: {
        "128": "src/img/icon_off.png"
      }
    })
  }
}

function convertISO8601Duration(t) {
  var x = t.split('T'),
    duration = '',
    time = {},
    period = {},
    s = 'string',
    v = 'variables',
    l = 'letters',
    d = {
      period: {
        string: x[0].substring(1, x[0].length),
        len: 4,
        letters: ['Y', 'M', 'W', 'D'],
        variables: {}
      },
      time: {
        string: x[1],
        len: 3,
        letters: ['H', 'M', 'S'],
        variables: {}
      }
    };

  if (!d.time.string) {
    d.time.string = '';
  }

  for (var i in d) {
    var len = d[i].len;
    for (var j = 0; j < len; j++) {
      d[i][s] = d[i][s].split(d[i][l][j]);
      if (d[i][s].length > 1) {
        d[i][v][d[i][l][j]] = parseInt(d[i][s][0], 10);
        d[i][s] = d[i][s][1];
      } else {
        d[i][v][d[i][l][j]] = 0;
        d[i][s] = d[i][s][0];
      }
    }
  }
  period = d.period.variables;
  time = d.time.variables;
  time.H += 24 * period.D +
    24 * 7 * period.W +
    24 * 7 * 4 * period.M +
    24 * 7 * 4 * 12 * period.Y;

  if (time.H) {
    duration = time.H + ':';
    if (time.M < 10) {
      time.M = '0' + time.M;
    }
  }

  if (time.S < 10) {
    time.S = '0' + time.S;
  }

  duration += time.M + ':' + time.S;
  return duration;
}

ajaxTwitch()
toogleStream(false)
ajaxYoutube()

setInterval(() => {
  ajaxTwitch()
  nowDate = new Date()
  hour = nowDate.getHours()
  min = nowDate.getMinutes()

  if (min === 0 && hour === 18) {
    ajaxYoutube()
  }

  if (min === 0 && hour === 0) {
    ajaxYoutube()
  }
}, 60000)